#include <stdlib.h>
#include <stdio.h>

#define N 2500
#define MAX 1000
#define MODUL 100
#define CAMINS ((N*N)/5)     

int m[N][N];

main()
{
	 int i,j,k;
	  long long s = 0;

	  //inicialització de la matriu
	  
	        #pragma omp parallel for private(i)
		for ( i = 0; i < N; i++ )
	                #pragma omp parallel for private(j)
			 for ( j = 0; j < N; j++ )
	              	    m[i][j] = MAX;
	  
	   
		for ( k = 0 ; k < CAMINS ; k++)
	          {
            	      i = rand()%N;//accedim a mateixa posicio de memoria
            	      j = rand()%N;
            	      m[i][j] = m[j][i] = rand()%MODUL;
          	   }

	       #pragma omp parallel for schedule(static,625)
	       for ( i = 0; i < N; i++ )
                       m[i][i] = 0;


//Daquesta manera conseguim evitar el problema de dependencies entre threads que teniem al ficar el pragma a al primer bucle. Aix es degut a que ara repartim la feina de manera seqencial per la k i parallela per les i's i j's de manera que al processador 1 li tocara les 625 i's, al segon les segents 625, al tercer...
//Ara els processadors no llegeixen i escriuen de les mateixes possicions de la matriu. Tamb hem decidit ficar la clausula first private per tal de que anem actualitzant les k correctament de manera sequencial.


		for ( k = 0; k < N; k++ )
		#pragma omp parallel private(i,j) firstprivate(k)
		 for ( i = 0; i < N; i++ )
		     for ( j = i+1; j < N; j++ )
	               if ( m[k][i] + m[k][j] < m[i][j])
                       m[j][i] = m[i][j] = m[k][i] + m[k][j];	 
	     s = 0;
	    
	    // #pragma omp parallel for private(i,j) reduction (+:s)
	     for ( i = 0; i < N;i++)
	        for ( j = i+1; j < N; j++ )
	             s+= m[i][j];  
	    

 printf("Suma %ld\n",s);
	
 }

